HalfsibMS <-
function(file){   
  options(scipen=200)
  mydata <<- read.csv(file,header=TRUE)
  if(colnames(mydata)[1]!="Site" && colnames(mydata)[1]!="Block"){
    stop("Data error with factor names!")
  }else if(colnames(mydata)[1]=="Site"){
    m <- ncol(mydata)
    Y <- mydata[,4:m]
    s <- unique(mydata[,1])
    b <- unique(mydata[,2])
    sb <- unique(mydata[,1:2])
    f <- unique(mydata[,3])
    sf <- unique(cbind((mydata[,1]),(mydata[,3])))
    sbf <- unique(mydata[,1:3])
    ns <- length(s)
    nb <- length(b)
    nsb <- nrow(sb)
    nf <- length(f)
    nsf <- nrow(sf)
    nsbf <- nrow(sbf)
    nc <- 1+ns+nsb+nf+nsf+nsbf
    n <- nrow(mydata)
    x1 <- matrix(0,nrow=n,ncol=1)
    x2 <- matrix(0,nrow=n,ncol=ns)
    x3 <- matrix(0,nrow=n,ncol=nsb)
    u1 <- matrix(0,nrow=n,ncol=nf)
    u2 <- matrix(0,nrow=n,ncol=nsf)
    u3 <- matrix(0,nrow=n,ncol=nsbf)
    for(i in 1:n){
      x1[i,1]=1
      for(j in 1:ns){
        if(mydata[i,1]==s[j])x2[i,j]=1
      }
      for(j in 1:nsb){
        if(mydata[i,1]==sb[j,1] && mydata[i,2]==sb[j,2])x3[i,j]=1
      }  
      for(j in 1:nf){
        if(mydata[i,3]==f[j])u1[i,j]=1
      }
      for(j in 1:nsf){
        if(mydata[i,1]==sf[j,1] && mydata[i,3]==sf[j,2])u2[i,j]=1
      }
      for(j in 1:nsbf){
        if(mydata[i,1]==sbf[j,1] && mydata[i,2]==sbf[j,2] && mydata[i,3]==sbf[j,3])u3[i,j]=1
      } 
    }
    x <- cbind(x1,x2,x3)
    xu1 <- cbind(x,u1)
    xu2 <- cbind(xu1,u2)
    xu3 <- cbind(xu2,u3)
    A4 <- diag(n)-xu3 %*% ginv(t(xu3) %*% xu3) %*% t(xu3)
    d0 <- qr(x)$rank
    d1 <- qr(xu1)$rank
    d2 <- qr(xu2)$rank
    d3 <- qr(xu3)$rank
    Q1 <- hld(xu3)[[1]]
    R1 <- hld(xu3)[[2]]
    Q2 <- giv(R1)[[1]]
    R2 <- giv(R1)[[2]]
    Q3 <- adj(R2,d3)[[1]]
    R <- adj(R2,d3)[[2]]
    nc1 <- 1:4
    nc1[1] <- 1+ns+nsb
    nc1[2] <- nc1[1]+nf
    nc1[3] <- nc1[2]+nsf
    nc1[4] <- nc1[3]+nsbf
    Q <- Q3 %*% (Q2 %*%Q1)
    x <- R[1:d3,1:(1+ns+nsb)]
    u1 <- R[1:d3,(1+1+ns+nsb):(1+ns+nsb+nf)]
    u2 <- R[1:d3,(1+1+ns+nsb+nf):(1+ns+nsb+nf+nsf)]
    u3 <- R[1:d3,(1+1+ns+nsb+nf+nsf):(1+ns+nsb+nf+nsf+nsbf)]
    xu1 <- cbind(x, u1)
    xu2 <- cbind(xu1,u2)
    xu3 <- cbind(xu2,u3) 
    X <- xu3
    L <- matrix(0,nrow=1,ncol=nc)
    for(i in 1:ns)L[1,1+i]=1
    for(i in 1:ns){
      L0 <- matrix(0,nrow=1,ncol=nc)
      for(j in 1:nsb){
        if(sb[j,1]==s[i])L0[1,1+ns+j]=1
      }
      L <- rbind(L,L0)
    }
    L0 <- matrix(0,nrow=1,ncol=nc)
    for(i in 1:nf)L0[1,1+ns+nsb+i]=1
    L <- rbind(L,L0)
    for(i in 1:ns){
      L0 <- matrix(0,nrow=1,ncol=nc)
      for(j in 1:nsf){
        if(sf[j,1]==s[i])L0[1,1+ns+nf+nsb+j]=1
      }
      L <- rbind(L,L0)
    }
    for(i in 1:nf){
      L0 <- matrix(0,nrow=1,ncol=nc)
      for(j in 1:nsf){
        if(sf[j,2]==f[i])L0[1,1+ns+nf+nsb+j]=1
      }
      L <- rbind(L,L0)
    }
    for(i in 1:nsb){
      L0 <- matrix(0,nrow=1,ncol=nc)
      for(j in 1:nsbf){
        if(sbf[j,1]==sb[i,1] && sbf[j,2]==sb[i,2])L0[1,1+ns+nf+nsb+nsf+j]=1   
      }
      L <- rbind(L,L0)
    }
    for(i in 1:nsf){
      L0 <- matrix(0,nrow=1,ncol=nc)
      for(j in 1:nsbf){
        if(sbf[j,1]==sf[i,1] && sbf[j,3]==sf[i,2])L0[1,1+ns+nf+nsb+nsf+j]=1   
      }
      L <- rbind(L,L0)
    }
    invxl <- solve(t(X) %*% X+t(L) %*% L)
    H0=matrix(0,nrow=(nc-1),ncol=nc)
    for(i in 1:(nc-1)){
      j=i+1
      H0[i,j]=1
    }
    H1 <- H0[1:ns,]
    H2 <- H0[ns+1:nsb,]
    H3 <- H0[ns+nsb+1:nf,]
    H4 <- H0[ns+nsb+nf+1:nsf,]
    H5 <- H0[ns+nsb+nf+nsf+1:nsbf,]
    TsM <- matrix(NA,nrow=3,ncol=5,dimnames=list(c("Model","Error","Total"),c("DF","Sum of Squares","Mean Squares","F Value","Pr>F")))
    TsM[1,1] <- ns*nb*nf-1
    TsM[2,1] <- n-ns*nb*nf
    TsM[3,1] <- n-1  
    TsF <- matrix(NA,nrow=5,ncol=5,dimnames=list(c("Site","Block/Site","Family","Site*Family","(Block/Site)*Family"),c("DF","Sum of Squares","Mean Squares","F Value","Pr>F")))
    TsF[1,1] <- ns-1
    TsF[2,1] <- ns*(nb-1)
    TsF[3,1] <- nf-1
    TsF[4,1] <- (ns-1)*(nf-1)
    TsF[5,1] <- ns*(nb-1)*(nf-1)
    Hk <- list(H1,H2,H3,H4,H5)  
    dimname <- c("u",paste("S",c(1:ns),sep=""))
    for(i in 1:nsb)dimname <- c(dimname,paste("SB(",sb[i,1],",",sb[i,2],")",sep=""))
    dimname <- c(dimname,paste("F",c(1:nf),sep=""))
    for(i in 1:nsf)dimname <- c(dimname,paste("SF(",sf[i,1],",",sf[i,2],")",sep=""))
    for(i in 1:nsbf)dimname <- c(dimname,paste("SBF(",sbf[i,1],",",sbf[i,2],",",sbf[i,3],")",sep=""))
    result1 <- matrix(0,nrow=nc,ncol=2,dimnames=list(dimname,c("Estimate","Std Errors")))
    tp <- matrix(0,nrow=nc,ncol=2,dimnames=list(c(),c("Tvalue","Pvalue")))
    tf <- matrix(NA,nrow=nf-1,ncol=nf-1,dimnames=list(paste("F",c(2:nf),sep=""),paste("F",c(1:(nf-1)),sep="")))
    pf <- matrix(NA,nrow=nf-1,ncol=nf-1,dimnames=list(paste("F",c(2:nf),sep=""),paste("F",c(1:(nf-1)),sep="")))
    result2 <- matrix(0,nrow=4,ncol=2,dimnames=list(c("Sigma_F","Sigma_SF","Sigma_SBF","Sigma_E"),c("Estimate","Std Errors")))
    d <- 1+ns+nsb
    A1 <- xu1 %*% ginv(t(xu1) %*% xu1) %*% t(xu1)-x %*% ginv(t(x) %*% x) %*% t(x)
    A2 <- xu2 %*% ginv(t(xu2) %*% xu2) %*% t(xu2)-xu1 %*% ginv(t(xu1) %*% xu1) %*% t(xu1)
    A3 <- xu3 %*% ginv(t(xu3) %*% xu3) %*% t(xu3)-xu2 %*% ginv(t(xu2) %*% xu2) %*% t(xu2)
    cm <- matrix(0,nrow=4,ncol=4)
    cm[1,1] <- tr(t(u1) %*% A1 %*% u1)
    cm[1,2] <- tr(t(u2) %*% A1 %*% u2)
    cm[1,3] <- tr(t(u3) %*% A1 %*% u3)
    cm[1,4] <- tr(A1)
    cm[2,2] <- tr(t(u2) %*% A2 %*% u2)
    cm[2,3] <- tr(t(u3) %*% A2 %*% u3)
    cm[2,4] <- tr(A2)
    cm[3,3] <- tr(t(u3) %*% A3 %*% u3)
    cm[3,4] <- tr(A3)
    cm[4,4] <- n-d3
    invcm <- solve(cm)   
    k1 <- R[(d0+1):d3,(nc1[1]+1):nc1[2]]  
    k2 <- R[(d0+1):d3,(nc1[2]+1):nc1[3]]
    k3 <- R[(d0+1):d3,(nc1[3]+1):nc1[4]]
    k3k3 <- k3 %*% t(k3)
    Dt <- diag(eigen(k3k3)[[1]])
    Pt <- eigen(k3k3)[[2]]
    Lt <- ((inv(Dt))^0.5) %*% t(Pt)
    g <- max(diag(inv(Dt)))
    nz <- d3-d0
    N1 <- Lt %*% k1
    N2 <- Lt %*% k2
    N <- cbind(N1,N2)
    QN1 <- hld(N)[[1]]
    RN1 <- hld(N)[[2]]
    QN2 <- giv(RN1)[[1]]
    RN2 <- giv(RN1)[[2]]
    QN3 <- adj(RN2,(d2-d0))[[1]]
    RN <- adj(RN2,(d2-d0))[[2]]
    QN <- QN3 %*% QN2 %*% QN1
    H <- QN %*% N
    k4 <- H[1:(d2-d0),1:(nc1[2]-nc1[1])]
    k5 <- H[1:(d2-d0),1:(nc1[3]-nc1[2])]
    k5k5 <- k5 %*% t(k5)
    Dt1 <- diag(eigen(k5k5)[[1]])
    Pt1 <- eigen(k5k5)[[2]]
    Lt1 <- ((inv(Dt1))^0.5) %*% t(Pt1)
    g1 <- max(diag(inv(Dt1)))
    nz1 <- d2-d0
    M <- Lt1 %*% k4
    QM1 <- hld(M)[[1]]
    RM1 <- hld(M)[[2]]
    QM2 <- giv(RM1)[[1]]
    RM2 <- giv(RM1)[[2]]
    QM3 <- adj(RM2,(d1-d0))[[1]]
    RM <- adj(RM2,(d1-d0))[[2]]
    QM <- QM3 %*% QM2 %*% QM1   
    nijk <- array(0,dim=c(ns,nb,nf))
    for(i in 1:ns)
      for(j in 1:nb)
        for(k in 1:nf)
          for(l in 1:n){
            if(mydata[l,1]==s[i] && mydata[l,2]==b[j] && mydata[l,3]==f[k])nijk[i,j,k]=nijk[i,j,k]+1
          }
    nk=array(0,dim=nf)
    nik=array(0,dim=c(ns,nf))
    for(i in 1:nf)nk[i]=sum(nijk[,,i])
    for(i in 1:ns)
      for(k in 1:nf)nik[i,k]=sum(nijk[i,,k])
    Ksf=Ksbf=Ke=0
    for(k in 1:nf){
      K0=0
      for(i in 1:ns)K0=K0+nik[i,k]^2
      Ksf=Ksf+K0/nk[k]^2
      K0=0
      for(i in 1:ns)
        for(j in 1:nb)K0=K0+nijk[i,j,k]^2      
      Ksbf=Ksbf+K0/nk[k]^2
      Ke=Ke+1/nk[k]
    }
    Ksf <- Ksf/nf
    Ksbf <- Ksbf/nf
    Ke <- Ke/nf
    Result1 <- list()
    TM <- list() 
    TF <- list()
    Tp <- list()
    Beta <- list()
    Tf <- list()
    Pf <- list()
    SI <- list()
    Var <- list()
    Result2 <- list()
    TFP <- list()
    Sigma <- list()
    write("              Analysis for the Model of Half-sib Progeny Test at Multi-site:",file="Result.txt")
    write("                  yijkl = u + Si + Bij + Fk + (SF)ik + (SBF)ijk + eijkl",file="Result.txt",append = TRUE)
    write(" ",file="Result.txt",append = TRUE)
    write(" ",file="Result.txt",append = TRUE)
    write("   *************************************************************************************",file="Result.txt",append = TRUE)
    write("   *                                                                                   *",file="Result.txt",append = TRUE)
    write(paste("   *  Result for the fixed effect model.                      ",date()," *",sep=""),file="Result.txt",append = TRUE)
    write("   *                                                                                   *",file="Result.txt",append = TRUE)
    write("   *************************************************************************************",file="Result.txt",append = TRUE)
    write(" ",file="Result.txt",append = TRUE)
    write(" ",file="Result.txt",append = TRUE) 
    for(i in 1:(m-3)){
      if(m==4){
        t <- Q %*% Y
      }else{
        t <- Q %*% (Y[,i])
      }
      beta <- invxl %*% t(X) %*% t[1:d3]
      sse <- t(t) %*% t-t(beta) %*% t(X) %*% t[1:d3]
      sigma <- sse/(n-d3)
      stdbeta <- (diag(invxl %*% t(X) %*% X %*% invxl)*sigma)^0.5
      result1[,1] <- beta
      result1[,2] <- stdbeta
      name <- paste("result1",i,sep="")
      assign(name,result1)
      Result1[[i]] <- result1    
      C <- rbind(L,H0)
      T <- t(X) %*% X+t(L) %*% L+t(H0) %*% H0
      invT <- solve(T)
      QT <- C %*% invT %*% t(C)
      betaH <- (invT-invT %*% t(C) %*% ginv(QT) %*% C %*% invT) %*% t(X) %*% t[1:d3]
      ssh <- t(t) %*% t-t(betaH) %*% t(X) %*% t[1:d3]
      df1 <- d3
      df2 <- nc-qr(C)$rank
      Ft <- ((ssh-sse)/(df1-df2))/(sse/(n-df1))
      p <- 1-pf(Ft,df1-df2,n-df1)
      TsM[1,2] <- ssh-sse
      TsM[2,2] <- sse
      TsM[3,2] <- ssh
      TsM[1,3] <- TsM[1,2]/TsM[1,1]
      TsM[2,3] <- TsM[2,2]/TsM[2,1]
      TsM[1,4] <- Ft
      TsM[1,5] <- p 
      TsM <- round(TsM,4)
      name <- paste("TSM",i,sep="")
      assign(name,TsM)
      TM[[i]] <- TsM 
      for(j in 1:5){
        C <- rbind(L,Hk[[j]]) 
        T <- t(X) %*% X+t(L) %*% L+t(Hk[[j]]) %*% Hk[[j]]
        invT <- solve(T)
        QT <- C %*% invT %*% t(C)
        betaH <- (invT-invT %*% t(C) %*% ginv(QT) %*% C %*% invT) %*% t(X) %*% t[1:d3]
        ssh <- t(t) %*% t-t(betaH) %*% t(X) %*% t[1:d3]
        df2 <- nc-qr(C)$rank
        Ft <- ((ssh-sse)/(df1-df2))/(sse/(n-df1))
        p <- 1-pf(Ft,df1-df2,n-df1)
        TsF[j,2] <- ssh-sse
        TsF[j,3] <- TsF[j,2]/TsF[j,1]
        TsF[j,4] <- Ft
        TsF[j,5] <- p
        TsF <- round(TsF,4)
      }
      name <- paste("TSF",i,sep="")
      assign(name,TsF)
      TF[[i]] <- TsF     
      for(j in 1:nc){
        H <- matrix(0,nrow=1,ncol=nc)
        H[1,j] <- 1
        C <- rbind(L,H)
        invT <- invxl-(invxl[,j] %*% t(invxl[,j]))/(1+invxl[j,j])
        QT <- C %*% invT %*% t(C)
        betaH <- (invT-invT %*% t(C) %*% ginv(QT) %*% C %*% invT) %*% t(X) %*% t[1:d3]
        ssh <- t(t) %*% t-t(betaH) %*% t(X) %*% t[1:d3]
        df2 <- nc-qr(C)$rank
        Ft <- ((ssh-sse)/(df1-df2))/(sse/(n-df1))
        P <- 1-pf(Ft,df1-df2,n-df1) 
        if(beta[j]>0)tp[j,1]=Ft^0.5 else tp[j,1]=-Ft^0.5 
        tp[j,2] <- P   
      }
      name <- paste("tp",i,sep = "")
      assign(name,tp)
      Tp[[i]] <- tp
      beta <- round(cbind(result1,tp),4)
      name <- paste("beta",i,sep = "")
      assign(name,beta)
      Beta[[i]] <- beta    
      for(j in 2:nf){
        for(k in 1:(j-1)){
          H=matrix(0,nrow=1,ncol=nc)
          jj=j+d
          kk=k+d
          H[1,jj]=1
          H[1,kk]=-1
          C=rbind(L,H)
          invT=invxl-(invxl[,jj]-invxl[,kk]) %*% t(invxl[,jj]-invxl[,kk])/(1+invxl[jj,jj]+invxl[kk,kk]-2*invxl[jj,kk])
          QT=C %*% invT %*% t(C)
          betaH=(invT-invT %*% t(C) %*% ginv(QT) %*% C %*% invT) %*% t(X) %*% t[1:d3]
          ssh=t(t) %*% t-t(betaH) %*% t(X) %*% t[1:d3]
          df2=nc-qr(C)$rank
          Ft=((ssh-sse)/(df1-df2))/(sse/(n-df1))
          P=1-pf(Ft,df1-df2,n-df1) 
          if((beta[k]-beta[j])>0)tf[j-1,k]=sprintf("%.4f",Ft^0.5) else  tf[j-1,k]=sprintf("%.4f",-Ft^0.5) 
          if(P<=0.01){
            pf[j-1,k]=paste(sprintf("%.4f",P),"**",sep="")
            tf[j-1,k]=paste(tf[j-1,k],"**",sep="")
          }
          else if(P>0.01&&P<=0.05){
            pf[j-1,k]=paste(sprintf("%.4f",P),"*",sep="")
            tf[j-1,k]=paste(tf[j-1,k],"*",sep="")
          }
          else{
            pf[j-1,k]=sprintf("%.4f",P)
            tf[j-1,k]=tf[j-1,k]
          }
        }
      }
      name <- paste("tf",i,sep="")
      assign(name,tf)
      Tf[[i]] <- tf
      name <- paste("pf",i,sep="")
      assign(name,pf)
      Pf[[i]] <- pf      
      write(paste("   Testing the model for trait ",i,":",sep=""),file="Result.txt",append = TRUE)
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write("      Source             DF     Sum of Squares     Mean Squares     F Value     Pr>F    ",file="Result.txt",append = TRUE)
      write("   -------------------------------------------------------------------------------------",file="Result.txt",append = TRUE)
      write(paste(sprintf("      %-5s",rownames(TM[[i]])[1]),sprintf("%16d",TM[[i]][1,1]),sprintf("%16.4f",TM[[i]][1,2]),sprintf("%17.4f",TM[[i]][1,3]),sprintf("%15.4f",TM[[i]][1,4]),sprintf("%10.4f",TM[[i]][1,5]),sep=""),file="Result.txt",append = TRUE)
      write(paste(sprintf("      %-5s",rownames(TM[[i]])[2]),sprintf("%16d",TM[[i]][2,1]),sprintf("%16.4f",TM[[i]][2,2]),sprintf("%17.4f",TM[[i]][2,3]),sep=""),file="Result.txt",append = TRUE)
      write(paste(sprintf("      %-5s",rownames(TM[[i]])[3]),sprintf("%16d",TM[[i]][3,1]),sprintf("%16.4f",TM[[i]][3,2]),sep=""),file="Result.txt",append = TRUE)
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write(" ",file="Result.txt",append = TRUE)  
      write(paste("   Testing factors for trait ",i,":",sep=""),file="Result.txt",append = TRUE)
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write("   Source                DF     Sum of Squares     Mean Squares     F Value     Pr>F    ",file="Result.txt",append = TRUE)
      write("   -------------------------------------------------------------------------------------",file="Result.txt",append = TRUE)
      for(j in 1:5){
        write(paste(sprintf("   %-19s",rownames(TF[[i]])[j]),sprintf("%5d",TF[[i]][j,1]),sprintf("%16.4f",TF[[i]][j,2]),sprintf("%17.4f",TF[[i]][j,3]),sprintf("%15.4f",TF[[i]][j,4]),sprintf("%10.4f",TF[[i]][j,5]),sep=""),file="Result.txt",append = TRUE)
      }
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write(" ",file="Result.txt",append = TRUE)
      write(paste("   Parameter estimates for trait ",i,":",sep=""),file="Result.txt",append = TRUE)
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write("      Parameter               Estimate       Std Error       T for H0:         Pr>|T|   ",file="Result.txt",append = TRUE)
      write("                                                            Parameter=0                 ",file="Result.txt",append = TRUE)
      write("   -------------------------------------------------------------------------------------",file="Result.txt",append = TRUE)
      for(j in 1:nc){
        write(paste(sprintf("      %-16s",rownames(Beta[[i]])[j]),sprintf("%15.4f",Beta[[i]][j,1]),sprintf("%16.4f",Beta[[i]][j,2]),sprintf("%17.4f",Beta[[i]][j,3]),sprintf("%15.4f",Beta[[i]][j,4]),sep=""),file="Result.txt",append = TRUE)
      }
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write(" ",file="Result.txt",append = TRUE)
      write(paste("   T values of test for difference between two families(females) for trait ",i,":",sep=""),file="Result.txt",append = TRUE)
      kw=c("   =========")
      kk=c("   ---------")
      v=c("        ")
      for(j in 1:(nf-1)){
        kw=paste(kw,"============",sep="")
        kk=paste(kk,"------------",sep="")  
        v=paste(v,sprintf("%12s",t(colnames(Tf[[i]])[j])),sep="")  
      }  
      write(kw,file="Result.txt",append = TRUE) 
      write(v,file="Result.txt",append = TRUE)
      write(kk,file="Result.txt",append = TRUE) 
      z1=1:(nf-1)
      for(j in 1:(nf-1)){
        z1[j]=sprintf("      %-9s",rownames(Tf[[i]])[j]) 
        for(k in 1:j){
          z1[j]=paste(z1[j],sprintf("%-12s",Tf[[i]][j,k]),sep="")
        }
        write(z1[j],file="Result.txt",append = TRUE)  
      }
      write(kw,file="Result.txt",append = TRUE) 
      write("   *p<0.05, **p<0.01",file="Result.txt",append = TRUE)
      write(" ",file="Result.txt",append = TRUE)
      write(" ",file="Result.txt",append = TRUE)
    }
    write("   *************************************************************************************",file="Result.txt",append = TRUE)
    write("   *                                                                                   *",file="Result.txt",append = TRUE)
    write(paste("   *  Result for the random effect model.                     ",date()," *",sep=""),file="Result.txt",append = TRUE)
    write("   *                                                                                   *",file="Result.txt",append = TRUE)
    write("   *************************************************************************************",file="Result.txt",append = TRUE)
    write(" ",file="Result.txt",append = TRUE)
    write(" ",file="Result.txt",append = TRUE)     
    for(i in 1:(m-3)){
      if(m==4){
        t <- Q %*% Y
        yay <- c(t(t[1:d3,]) %*% A1 %*% t[1:d3,],t(t[1:d3,]) %*% A2 %*% t[1:d3,],t(t[1:d3,]) %*% A3 %*% t[1:d3,],t(Y) %*% A4 %*% Y)
      }else{
        t <- Q %*% (Y[,i])
        yay <- c(t(t[1:d3,]) %*% A1 %*% t[1:d3,],t(t[1:d3,]) %*% A2 %*% t[1:d3,],t(t[1:d3,]) %*% A3 %*% t[1:d3,],t(Y[,i]) %*% A4 %*% Y[,i])
      }
      result2[,1] <- invcm %*% yay
      S <- (u1 %*% t(u1))*result2[1,1] + (u2 %*% t(u2))*result2[2,1] + (u3 %*% t(u3))*result2[3,1] + diag(d3)*result2[4,1]
      name <- paste("S",i,sep="")
      assign(name,S)
      SI[[i]] <- S
      tra1sa1s <- tr(A1 %*% S %*% A1 %*% S)
      tra2sa2s <- tr(A2 %*% S %*% A2 %*% S)
      tra3sa3s <- tr(A3 %*% S %*% A3 %*% S)
      tra4sa4s <- (n-d3)*result2[4,1]^2
      tra1sa2s <- tr(A1 %*% S %*% A2 %*% S)
      tra1sa3s <- tr(A1 %*% S %*% A3 %*% S)
      tra2sa3s <- tr(A2 %*% S %*% A3 %*% S)
      trasas <- c(tra1sa1s,tra2sa2s,tra3sa3s,tra4sa4s)
      vf <- 2*(invcm[1,]^2 %*% trasas)+4*invcm[1,1]*invcm[1,2]*tra1sa2s+4*invcm[1,1]*invcm[1,3]*tra1sa3s+4*invcm[1,2]*invcm[1,3]*tra2sa3s
      vsf <- 2*(invcm[2,]^2 %*% trasas)+4*invcm[2,2]*invcm[2,3]*tra2sa3s
      vsbf <- 2*(invcm[3,]^2 %*% trasas)
      ve <- 2*(invcm[4,]^2 %*% trasas)
      var <- c(vf,vsf,vsbf,ve)
      name <- paste("var",i,sep="")
      assign(name,var)
      Var[[i]] <- var
      result2[,2] <- (c(vf,vsf,vsbf,ve))^0.5
      name <- paste("result2",i,sep="")
      assign(name,result2)
      Result2[[i]] <- result2
      t3 <- t[(d2+1):d3]
      t4 <- t[(d3+1):n]
      FSBF <- (t(t3) %*% t3/(d3-d2))/(t(t4) %*% t4/(n-d3))
      PSBF <- 1-pf(FSBF,d3-d2,n-d3)
      z <- Lt %*% t[(d0+1):d3]
      ts <- t[(d3+1):(d3+nz)]
      u <- z+((g*diag(1,nz)-inv(Dt))^0.5) %*% ts
      w <- QN %*% u
      w1 <- w[1:(d1-d0)]
      w2 <- w[(d1-d0+1):(d2-d0)]
      w3 <- w[(d2-d0+1):(d3-d0)]
      FSF <- (t(w2) %*% w2/(d2-d1))/(t(w3) %*% w3/(d3-d2))
      PSF <- 1-pf(FSF,d2-d1,d3-d2) 
      Z <- Lt1 %*% w[1:(d2-d0)]
      Ts <- w[(d2-d0+1):(d2-d0+nz1)]
      U <- Z+((g1*diag(1,nz1)-inv(Dt1)))^0.5 %*% Ts
      v <- QM %*% U
      v1 <- v[1:(d1-d0)]
      v2 <- v[(d1-d0+1):(d2-d0)]
      FF <- (t(v1) %*% v1/(d1-d0))/(t(v2) %*% v2/(d2-d1))
      PF <- 1-pf(FF,d1-d0,d2-d1)
      F_value <- c(FF,FSF,FSBF)
      P_value <- c(PF,PSF,PSBF)
      na <- t(c(NA,NA))
      FP <- rbind(cbind(F_value,P_value),na)
      name <- paste("FP",i,sep="")
      assign(name,FP)
      TFP[[i]] <- FP   
      hf <- result2[1,1]/(result2[1,1]+result2[2,1]*Ksf+result2[3,1]*Ksbf+result2[4,1]*Ke)
      hi <- 4*result2[1,1]/(result2[1,1]+result2[2,1]+result2[3,1]+result2[4,1])
      K <- result2[1,1]+result2[2,1]*Ksf+result2[3,1]*Ksbf+result2[4,1]*Ke
      cv1 <- invcm[1,1]*invcm[2,2]*2*tra1sa2s+invcm[1,1]*invcm[2,3]*2*tra1sa3s+invcm[1,2]*invcm[2,2]*2*tra2sa2s+2*(invcm[1,2]*invcm[2,3]+invcm[1,3]*invcm[2,2])*tra2sa3s+invcm[1,3]*invcm[2,3]*2*tra3sa3s+invcm[1,4]*invcm[2,4]*2*(n-d3)*result2[4,1]^2
      cv2 <- invcm[1,1]*invcm[3,3]*2*tra1sa3s+invcm[1,2]*invcm[3,3]*2*tra2sa3s+invcm[1,3]*invcm[3,3]*2*tra3sa3s+invcm[1,4]*invcm[3,4]*2*(n-d3)*result2[4,1]^2
      cv3 <- invcm[2,2]*invcm[3,3]*2*tra2sa3s+invcm[2,3]*invcm[3,3]*2*tra3sa3s+invcm[2,4]*invcm[3,4]*2*(n-d3)*result2[4,1]^2
      cv4 <- invcm[1,4]*invcm[4,4]*2*(n-d3)*result2[4,1]^2
      cv5 <- invcm[2,4]*invcm[4,4]*2*(n-d3)*result2[4,1]^2
      cv6 <- invcm[3,4]*invcm[4,4]*2*(n-d3)*result2[4,1]^2
      stdhf <- (((result2[1,2])/K)^2+(result2[1,1]^2)*(result2[1,2]^2+(Ksf*result2[2,2])^2+(Ksbf*result2[3,2])^2+(Ke*result2[4,2])^2+2*Ksf*cv1+2*Ksbf*cv2+2*Ksf*Ksbf*cv3+2*Ke*cv4+2*Ksf*Ke*cv5+2*Ksbf*Ke*cv6)/(K^4)-2*result2[1,1]*(result2[1,2]^2+Ksf*cv1+Ksbf*cv2+Ke*cv4)/K^3)^0.5
      Th <- sum(result2[,1])
      stdhi <- (16*((result2[1,2])/Th)^2+16*(result2[1,1]^2)*(result2[1,2]^2+result2[2,2]^2+result2[3,2]^2+result2[4,2]^2+2*cv1+2*cv2+2*cv3+2*cv4+2*cv5+2*cv6)/(Th^4)-32*result2[1,1]*(result2[1,2]^2+cv1+cv2+cv4)/Th^3)^0.5
      h <- c(hf,hi)
      stdh <- c(stdhf,stdhi)
      H <- cbind(h,stdh)
      nah <- matrix(NA,nrow=2,ncol=2)
      H <- cbind(H,nah)
      rownames(H) <- c(paste("Hf",i,sep=""),paste("Hi",i,sep=""))
      sigma <- cbind(result2,FP)
      sigma <- round(rbind(sigma,H),4)
      name <- paste("sigma",i,sep="")
      assign(name,sigma)
      Sigma[[i]] <- sigma 
      write(paste("   Estimates of variance components and heritabilites for trait ",i,":",sep=""),file="Result.txt",append = TRUE)
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write("      Parameter            Estimate           Std Error        F For H0:        Pr > F  ",file="Result.txt",append = TRUE)
      write("                                                              Parameter=0               ",file="Result.txt",append = TRUE)
      write("   -------------------------------------------------------------------------------------",file="Result.txt",append = TRUE)
      Rnames=c("Sigma_F","Sigma_SF","Sigma_SBF","Sigma_E","Hf","Hi")
      for(j in 1:3){
        write(paste(sprintf("      %-9s",Rnames[j]),sprintf("%19.4f",Sigma[[i]][j,1]),sprintf("%20.4f",Sigma[[i]][j,2]),sprintf("%16.4f",Sigma[[i]][j,3]),sprintf("%16.4f",Sigma[[i]][j,4]),sep=""),file="Result.txt",append = TRUE)
      }
      write(paste(sprintf("      %-9s",Rnames[4]),sprintf("%19.4f",Sigma[[i]][4,1]),sprintf("%20.4f",Sigma[[i]][4,2]),sep=""),file="Result.txt",append = TRUE)
      write(" ",file="Result.txt",append = TRUE)
      for(j in 5:6){
        write(paste(sprintf("      %-9s",Rnames[j]),sprintf("%19.4f",Sigma[[i]][j,1]),sprintf("%20.4f",Sigma[[i]][j,2]),sep=""),file="Result.txt",append = TRUE)
      }
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write(" ",file="Result.txt",append = TRUE)
    }
    if(m > 4){
      GC <- list()
      EGC <- list()
      GCS <- list() 
      GCf <- matrix(NA,nrow=m-3,ncol=m-3,dimnames=list(c(1:(m-3)),c(1:(m-3))))
      GCsf <- matrix(NA,nrow=m-3,ncol=m-3,dimnames=list(c(1:(m-3)),c(1:(m-3))))
      GCsbf <- matrix(NA,nrow=m-3,ncol=m-3,dimnames=list(c(1:(m-3)),c(1:(m-3))))
      diag(GCf)<-"1.0000"
      diag(GCsf)<-"1.0000"
      diag(GCsbf)<-"1.0000"
      GCef <- matrix(NA,nrow=m-3,ncol=m-3,dimnames=list(c(1:(m-3)),c(1:(m-3))))
      GCesf <- matrix(NA,nrow=m-3,ncol=m-3,dimnames=list(c(1:(m-3)),c(1:(m-3))))
      GCesbf <- matrix(NA,nrow=m-3,ncol=m-3,dimnames=list(c(1:(m-3)),c(1:(m-3))))
      diag(GCef)<-"0.0000"
      diag(GCesf)<-"0.0000"
      diag(GCesbf)<-"0.0000"
      GCMf <- matrix(NA,nrow=m-3,ncol=m-3,dimnames=list(paste("Trait",c(1:(m-3)),sep=""),paste("Trait",c(1:(m-3)),sep="")))
      GCMsf <- matrix(NA,nrow=m-3,ncol=m-3,dimnames=list(paste("Trait",c(1:(m-3)),sep=""),paste("Trait",c(1:(m-3)),sep="")))
      GCMsbf <- matrix(NA,nrow=m-3,ncol=m-3,dimnames=list(paste("Trait",c(1:(m-3)),sep=""),paste("Trait",c(1:(m-3)),sep="")))
      diag(GCMf)<-paste("1.0000","(0.0000)",sep="")
      diag(GCMsf)<-paste("1.0000","(0.0000)",sep="")
      diag(GCMsbf)<-paste("1.0000","(0.0000)",sep="")
      nt=0
      for(i in 1:(m-4)){
        for(j in (i+1):(m-3)){
          t1 <- Q %*% Y[,i]
          t2 <- Q %*% Y[,j]
          y1ay2 <- c(t(t1[1:d3,]) %*% A1 %*% t2[1:d3,],t(t1[1:d3,]) %*% A2 %*% t2[1:d3,],t(t1[1:d3,]) %*% A3 %*% t2[1:d3,],t(Y[,i]) %*% A4 %*% Y[,j])
          cov <- c(invcm %*% y1ay2)
          rf <- cov[1]/(Result2[[i]][1,1]*Result2[[j]][1,1])^0.5
          rsf <- cov[2]/(Result2[[i]][2,1]*Result2[[j]][2,1])^0.5
          rsbf <- cov[3]/(Result2[[i]][3,1]*Result2[[j]][3,1])^0.5 
          Gc <- c(rf,rsf,rsbf)
          name <- paste("Gc",i,j,sep="")
          assign(name,Gc)
          S12 <- (u1 %*% t(u1))*cov[1]+(u2 %*% t(u2))*cov[2]+(u3 %*% t(u3))*cov[3]+diag(d3)*cov[4]
          tra1s1a1s12 <- tr(A1 %*% SI[[i]] %*% A1 %*% S12)
          tra2s1a2s12 <- tr(A2 %*% SI[[i]] %*% A2 %*% S12)
          tra3s1a3s12 <- tr(A3 %*% SI[[i]] %*% A3 %*% S12)
          tra4s1a4s12 <- (n-d3)*Result2[[i]][4,1]*cov[4]
          tra1s1a2s12 <- tr(A1 %*% SI[[i]] %*% A2 %*% S12)
          tra1s1a3s12 <- tr(A1 %*% SI[[i]] %*% A3 %*% S12)
          tra2s1a3s12 <- tr(A2 %*% SI[[i]] %*% A3 %*% S12)
          trasas121 <- c(tra1s1a1s12,tra2s1a2s12,tra3s1a3s12,tra4s1a4s12)
          tra1s2a1s12 <- tr(A1 %*% SI[[j]] %*% A1 %*% S12)
          tra2s2a2s12 <- tr(A2 %*% SI[[j]] %*% A2 %*% S12)
          tra3s2a3s12 <- tr(A3 %*% SI[[j]] %*% A3 %*% S12)
          tra4s2a4s12 <- (n-d3)*Result2[[j]][4,1]*cov[4]
          tra1s2a2s12 <- tr(A1 %*% SI[[j]] %*% A2 %*% S12)
          tra1s2a3s12 <- tr(A1 %*% SI[[j]] %*% A3 %*% S12)
          tra2s2a3s12 <- tr(A2 %*% SI[[j]] %*% A3 %*% S12)
          trasas122 <- c(tra1s2a1s12,tra2s2a2s12,tra3s2a3s12,tra4s2a4s12)
          tra1s12a1s12 <- tr(A1 %*% S12 %*% A1 %*% S12)
          tra2s12a2s12 <- tr(A2 %*% S12 %*% A2 %*% S12)
          tra3s12a3s12 <- tr(A3 %*% S12 %*% A3 %*% S12)
          tra4s12a4s12 <- (n-d3)*cov[4]^2
          tra1s12a2s12 <- tr(A1 %*% S12 %*% A2 %*% S12)
          tra1s12a3s12 <- tr(A1 %*% S12 %*% A3 %*% S12)
          tra2s12a3s12 <- tr(A2 %*% S12 %*% A3 %*% S12)
          trasas1212 <- c(tra1s12a1s12,tra2s12a2s12,tra3s12a3s12,tra4s12a4s12)
          tra1s1a1s2 <- tr(A1 %*% SI[[i]] %*% A1 %*% SI[[j]])
          tra2s1a2s2 <- tr(A2 %*% SI[[i]] %*% A2 %*% SI[[j]])
          tra3s1a3s2 <- tr(A3 %*% SI[[i]] %*% A3 %*% SI[[j]])
          tra4s1a4s2 <- (n-d3)*Result2[[i]][4,1]*Result2[[j]][4,1]
          tra1s1a2s2 <- tr(A1 %*% SI[[i]] %*% A2 %*% SI[[j]])
          tra1s1a3s2 <- tr(A1 %*% SI[[i]] %*% A3 %*% SI[[j]])
          tra2s1a3s2 <- tr(A2 %*% SI[[i]] %*% A3 %*% SI[[j]])
          trasas12 <- c(tra1s1a1s2,tra2s1a2s2,tra3s1a3s2,tra4s1a4s2)
          vf12 <- invcm[1,]^2 %*% (trasas1212+trasas12)+2*invcm[1,1]*invcm[1,2]*(tra1s12a2s12+tra1s1a2s2)+2*invcm[1,1]*invcm[1,3]*(tra1s12a3s12+tra1s1a3s2)+2*invcm[1,2]*invcm[1,3]*(tra2s12a3s12+tra2s1a3s2)
          cvf121 <- 2*(invcm[1,]^2 %*% trasas121)+4*invcm[1,1]*invcm[1,2]*tra1s1a2s12+4*invcm[1,1]*invcm[1,3]*tra1s1a3s12+4*invcm[1,2]*invcm[1,3]*tra2s1a3s12
          cvf122 <- 2*(invcm[1,]^2 %*% trasas122)+4*invcm[1,1]*invcm[1,2]*tra1s2a2s12+4*invcm[1,1]*invcm[1,3]*tra1s2a3s12+4*invcm[1,2]*invcm[1,3]*tra2s2a3s12
          cvf1f2 <- 2*(invcm[1,]^2 %*% trasas1212)+4*invcm[1,1]*invcm[1,2]*tra1s12a2s12+4*invcm[1,1]*invcm[1,3]*tra1s12a3s12+4*invcm[1,2]*invcm[1,3]*tra2s12a3s12
          vrf <- (vf12/cov[1]^2+Var[[i]][1]/(4*Result2[[i]][1,1]^2)+Var[[j]][1]/(4*Result2[[j]][1,1]^2)-cvf121/(cov[1]*Result2[[i]][1,1])-cvf122/(cov[1]*Result2[[j]][1,1])+cvf1f2/(2*Result2[[i]][1,1]*Result2[[j]][1,1]))*rf^2
          erf <- vrf^0.5
          vsf12 <- invcm[2,]^2 %*% (trasas1212+trasas12)+2*invcm[2,2]*invcm[2,3]*(tra2s12a3s12+tra2s1a3s2)
          cvsf121 <- 2*(invcm[2,]^2 %*% trasas121)+4*invcm[2,2]*invcm[2,3]*tra2s1a3s12
          cvsf122 <- 2*(invcm[2,]^2 %*% trasas122)+4*invcm[2,2]*invcm[2,3]*tra2s2a3s12
          cvsf1sf2 <- 2*(invcm[2,]^2 %*% trasas1212)+4*invcm[2,2]*invcm[2,3]*tra2s12a3s12
          vrsf <- (vsf12/cov[2]^2+Var[[i]][2]/(4*Result2[[i]][2,1]^2)+Var[[j]][2]/(4*Result2[[j]][2,1]^2)-cvsf121/(cov[2]*Result2[[i]][2,1])-cvsf122/(cov[2]*Result2[[j]][2,1])+cvsf1sf2/(2*Result2[[i]][2,1]*Result2[[j]][2,1]))*rsf^2
          ersf <- vrsf^0.5 
          vsbf12 <- invcm[3,]^2 %*% (trasas1212+trasas12)
          cvsbf121 <- 2*(invcm[3,]^2 %*% trasas121)
          cvsbf122 <- 2*(invcm[3,]^2 %*% trasas122)
          cvsbf1sbf2 <- 2*(invcm[3,]^2 %*% trasas1212)    
          vrsbf <- (vsbf12/cov[3]^2+Var[[i]][3]/(4*Result2[[i]][3,1]^2)+Var[[j]][3]/(4*Result2[[j]][3,1]^2)-cvsbf121/(cov[3]*Result2[[i]][3,1])-cvsbf122/(cov[3]*Result2[[j]][3,1])+cvsbf1sbf2/(2*Result2[[i]][3,1]*Result2[[j]][3,1]))*rsbf^2
          ersbf <- vrsbf^0.5
          EGc <- c(erf,ersf,ersbf)
          name <- paste("EGc",i,j,sep="")
          assign(name,EGc)
          GCs <- round(cbind(Gc,EGc),4)
          rownames(GCs) <- c(paste("GC",i,j,"_F",sep=""),paste("GC",i,j,"_SF",sep=""),paste("GC",i,j,"_SBF",sep=""))
          colnames(GCs) <- c("GC","Std Error")
          name <- paste("GCs",i,j,sep="")
          assign(name,GCs)
          nt <- nt+1
          GC[[nt]] <- Gc
          EGC[[nt]] <- EGc
          GCS[[nt]] <- GCs
          GCf[i,j] <- GCf[j,i] <- sprintf("%.4f",GCs[1,1])
          GCsf[i,j] <- GCsf[j,i] <- sprintf("%.4f",GCs[2,1])
          GCsbf[i,j] <- GCsbf[j,i] <- sprintf("%.4f",GCs[3,1])
          GCef[i,j] <- GCef[j,i] <- sprintf("%.4f",GCs[1,2])
          GCesf[i,j] <- GCesf[j,i] <- sprintf("%.4f",GCs[2,2])
          GCesbf[i,j] <- GCesbf[j,i] <- sprintf("%.4f",GCs[3,2])
          GCMf[i,j] <- GCMf[j,i] <- paste(sprintf("%.4f",GCs[1,1]),paste("(",sprintf("%.4f",GCs[1,2]),")",sep=""),sep="")
          GCMsf[i,j] <- GCMsf[j,i] <- paste(sprintf("%.4f",GCs[2,1]),paste("(",sprintf("%.4f",GCs[2,2]),")",sep=""),sep="")
          GCMsbf[i,j] <- GCMsbf[j,i] <- paste(sprintf("%.4f",GCs[3,1]),paste("(",sprintf("%.4f",GCs[3,2]),")",sep=""),sep="")
        } 
      } 
      write("   Genetic correlation matrix of family effects with standard error in brackets",file="Result.txt",append = TRUE)
      kw=c("   ===============")
      kk=c("   ---------------")
      v=c("       Trait")
      for(i in 1:(m-3)){
        kw=paste(kw,"=============",sep="")
        kk=paste(kk,"-------------",sep="")  
        v=paste(v,sprintf("%13s",t(colnames(GCf)[i])),sep="")  
      }  
      write(kw,file="Result.txt",append = TRUE) 
      write(v,file="Result.txt",append = TRUE)
      write(kk,file="Result.txt",append = TRUE)
      zf=1:(m-3)
      zef=1:(m-3)
      for(i in 1:(m-3)){
        zf[i]=sprintf("         %1s    ",rownames(GCf)[i])
        zef[i]=sprintf("               ")
        for(j in 1:(m-3)){
          zf[i]=paste(zf[i],sprintf("%13s",GCf[i,j]),sep="")
          zef[i]=paste(zef[i],sprintf("%13s",paste("(",GCef[i,j],")",sep="")),sep="")
        }
      }
      for(i in 1:(m-4)){
        write(zf[i],file="Result.txt",append = TRUE) 
        write(zef[i],file="Result.txt",append = TRUE) 
        write("     ",file="Result.txt",append = TRUE) 
      }    
      write(zf[m-3],file="Result.txt",append = TRUE) 
      write(zef[m-3],file="Result.txt",append = TRUE)
      write(kw,file="Result.txt",append = TRUE)
      write("     ",file="Result.txt",append = TRUE)
      write("   Genetic correlation matrix of site*family effects with standard error in brackets",file="Result.txt",append = TRUE)
      kw=c("   ===============")
      kk=c("   ---------------")
      v=c("       Trait")
      for(i in 1:(m-3)){
        kw=paste(kw,"=============",sep="")
        kk=paste(kk,"-------------",sep="")  
        v=paste(v,sprintf("%13s",t(colnames(GCsf)[i])),sep="")  
      }  
      write(kw,file="Result.txt",append = TRUE) 
      write(v,file="Result.txt",append = TRUE)
      write(kk,file="Result.txt",append = TRUE)
      zsf=1:(m-3)
      zesf=1:(m-3)
      for(i in 1:(m-3)){
        zsf[i]=sprintf("         %1s    ",rownames(GCsf)[i])
        zesf[i]=sprintf("               ")
        for(j in 1:(m-3)){
          zsf[i]=paste(zsf[i],sprintf("%13s",GCsf[i,j]),sep="")
          zesf[i]=paste(zesf[i],sprintf("%13s",paste("(",GCesf[i,j],")",sep="")),sep="")
        }
      }
      for(i in 1:(m-4)){
        write(zsf[i],file="Result.txt",append = TRUE) 
        write(zesf[i],file="Result.txt",append = TRUE) 
        write("     ",file="Result.txt",append = TRUE) 
      }    
      write(zsf[m-3],file="Result.txt",append = TRUE) 
      write(zesf[m-3],file="Result.txt",append = TRUE)
      write(kw,file="Result.txt",append = TRUE) 
      write("     ",file="Result.txt",append = TRUE)
      write("   Genetic correlation matrix of (block/site)*family effects with standard error in brackets",file="Result.txt",append = TRUE)
      kw=c("   ===============")
      kk=c("   ---------------")
      v=c("       Trait")
      for(i in 1:(m-3)){
        kw=paste(kw,"=============",sep="")
        kk=paste(kk,"-------------",sep="")  
        v=paste(v,sprintf("%13s",t(colnames(GCsbf)[i])),sep="")  
      }  
      write(kw,file="Result.txt",append = TRUE) 
      write(v,file="Result.txt",append = TRUE)
      write(kk,file="Result.txt",append = TRUE)
      zsbf=1:(m-3)
      zesbf=1:(m-3)
      for(i in 1:(m-3)){
        zsbf[i]=sprintf("         %1s    ",rownames(GCsbf)[i])
        zesbf[i]=sprintf("               ")
        for(j in 1:(m-3)){
          zsbf[i]=paste(zsbf[i],sprintf("%13s",GCsbf[i,j]),sep="")
          zesbf[i]=paste(zesbf[i],sprintf("%13s",paste("(",GCesbf[i,j],")",sep="")),sep="")
        }
      }
      for(i in 1:(m-4)){
        write(zsbf[i],file="Result.txt",append = TRUE) 
        write(zesbf[i],file="Result.txt",append = TRUE) 
        write("     ",file="Result.txt",append = TRUE) 
      }    
      write(zsbf[m-3],file="Result.txt",append = TRUE) 
      write(zesbf[m-3],file="Result.txt",append = TRUE)
      write(kw,file="Result.txt",append = TRUE)
    }
  }else if(colnames(mydata)[1]=="Block"){
    m <- ncol(mydata)
    Y <- mydata[,3:m]
    b <- unique(mydata[,1])
    f <- unique(mydata[,2])
    bf <- unique(mydata[,1:2])
    nb <- length(b)
    nf <- length(f)
    nbf <- nrow(bf)
    nc <- 1+nb+nf+nbf
    n <- nrow(mydata)
    x1 <- matrix(0,nrow=n,ncol=1)
    x2 <- matrix(0,nrow=n,ncol=nb)
    u1 <- matrix(0,nrow=n,ncol=nf)
    u2 <- matrix(0,nrow=n,ncol=nbf)
    for(i in 1:n){
      x1[i,1]=1
      for(j in 1:nb){
        if(mydata[i,1]==b[j])x2[i,j]=1
      }  
      for(j in 1:nf){
        if(mydata[i,2]==f[j])u1[i,j]=1
      }
      for(j in 1:nbf){
        if(mydata[i,1]==bf[j,1] && mydata[i,2]==bf[j,2])u2[i,j]=1
      } 
    }
    x <- cbind(x1,x2)
    xu1 <- cbind(x,u1)
    xu2 <- cbind(xu1,u2)
    A3 <- diag(n)-xu2 %*% ginv(t(xu2) %*% xu2) %*% t(xu2)
    d0 <- qr(x)$rank
    d1 <- qr(xu1)$rank
    d2 <- qr(xu2)$rank
    Q1 <- hld(xu2)[[1]]
    R1 <- hld(xu2)[[2]]
    Q2 <- giv(R1)[[1]]
    R2 <- giv(R1)[[2]]
    Q3 <- adj(R2,d2)[[1]]
    R <- adj(R2,d2)[[2]]
    nc1 <- 1:3
    nc1[1] <- 1+nb
    nc1[2] <- nc1[1]+nf
    nc1[3] <- nc1[2]+nbf
    Q <- Q3%*%(Q2%*%Q1)
    x <- R[1:d2,1:(1+nb)]
    u1 <- R[1:d2,(1+1+nb):(1+nb+nf)]
    u2 <- R[1:d2,(1+1+nb+nf):(1+nb+nf+nbf)]
    xu1 <- cbind(x,u1)
    xu2 <- cbind(xu1,u2)
    X <- xu2
    L <- matrix(0,nrow=2,ncol=nc)
    for(i in 1:nb)L[1,1+i]=1
    for(i in 1:nf)L[2,1+nb+i]=1
    for(i in 1:nb){
      L0=matrix(0,nrow=1,ncol=nc)
      for(j in 1:nbf){
        if(bf[j,1]==b[i])L0[1,1+nb+nf+j]=1
      }
      L=rbind(L,L0)
    }
    for(i in 1:nf){
      L0=matrix(0,nrow=1,ncol=nc)
      for(j in 1:nbf){
        if(bf[j,2]==f[i])L0[1,1+nb+nf+j]=1
      }
      L=rbind(L,L0)
    }
    invxl <- solve(t(X)%*%X+t(L)%*%L)
    H0 <- matrix(0,nrow=(nc-1),ncol=nc)
    for(i in 1:(nc-1)){
      j=i+1
      H0[i,j]=1
    }
    H1 <- H0[1:nb,]
    H2 <- H0[nb+1:nf,]
    H3 <- H0[nb+nf+1:nbf,]  
    TsM <- matrix(NA,nrow=3,ncol=5,dimnames=list(c("Model","Error","Total"),c("DF","Sum of Squares","Mean Squares","F Value","Pr>F")))
    TsM[1,1] <- nb*nf-1
    TsM[2,1] <- n-nb*nf
    TsM[3,1] <- n-1
    TsF <- matrix(NA,nrow=3,ncol=5,dimnames=list(c("Block","Family","Block*Family"),c("DF","Sum of Squares","Mean Squares","F Value","Pr>F")))
    TsF[1,1] <- nb-1
    TsF[2,1] <- nf-1
    TsF[3,1] <- (nb-1)*(nf-1)
    Hk <- list(H1,H2,H3)
    dimname <- c("u",paste("B",c(1:nb),sep=""),paste("F",c(1:nf),sep=""))
    for(i in 1:nbf)dimname=c(dimname,paste("BF(",bf[i,1],",",bf[i,2],")",sep=""))
    result1 <- matrix(0,nrow=nc,ncol=2,dimnames=list(dimname,c("Estimate","Std Errors")))
    tp <- matrix(0,nrow=nc,ncol=2,dimnames=list(c(),c("Tvalue","Pvalue")))
    tf <- matrix(NA,nrow=nf-1,ncol=nf-1,dimnames=list(paste("F",c(2:nf),sep=""),paste("F",c(1:(nf-1)),sep="")))
    pf <- matrix(NA,nrow=nf-1,ncol=nf-1,dimnames=list(paste("F",c(2:nf),sep=""),paste("F",c(1:(nf-1)),sep="")))
    result2 <- matrix(0,nrow=3,ncol=2,dimnames=list(c("Sigma_F","Sigma_BF","Sigma_E"),c("Estimate","Std Errors")))
    d <- 1+nb
    A1 <- xu1 %*% ginv(t(xu1) %*% xu1) %*% t(xu1)-x %*% ginv(t(x) %*% x) %*% t(x)
    A2 <- xu2 %*% ginv(t(xu2) %*% xu2) %*% t(xu2)-xu1 %*% ginv(t(xu1) %*% xu1) %*% t(xu1)    
    cm <- matrix(0,nrow=3,ncol=3)
    cm[1,1] <- tr(t(u1) %*% A1 %*% u1)
    cm[1,2] <- tr(t(u2) %*% A1 %*% u2)
    cm[1,3] <- tr(A1)
    cm[2,2] <- tr(t(u2) %*% A2 %*% u2)
    cm[2,3] <- tr(A2)
    cm[3,3] <- tr(A3)
    invcm <- solve(cm)   
    k1 <- R[(d0+1):d2,(nc1[1]+1):nc1[2]] 
    k2 <- R[(d0+1):d2,(nc1[2]+1):nc1[3]]
    k2k2 <- k2 %*% t(k2)
    Dt <- diag(eigen(k2k2)[[1]])
    Pt <- eigen(k2k2)[[2]]
    Lt <- ((inv(Dt))^0.5) %*% t(Pt)
    g <- max(diag(inv(Dt)))
    nz <- d2-d0
    N <- Lt %*% k1
    QN1 <- hld(N)[[1]]
    RN1 <- hld(N)[[2]]
    QN2 <- giv(RN1)[[1]]
    RN2 <- giv(RN1)[[2]]
    QN3 <- adj(RN2,(d1-d0))[[1]]
    RN <- adj(RN2,(d1-d0))[[2]]
    QN <- QN3 %*% QN2 %*% QN1 
    nij <- matrix(0,nrow=nb,ncol=nf)
    for(i in 1:nb)
      for(j in 1:nf)
        for(k in 1:n){
          if(mydata[k,1]==b[i] && mydata[k,2]==f[j])nij[i,j]=nij[i,j]+1
        }
    nj=colSums(nij)
    Kbf=Ke=0
    for(j in 1:nf){
      k0=0
      for(i in 1:nb){
        k0=k0+nij[i,j]^2
      }
      Kbf=Kbf+k0/nj[j]^2
      Ke=Ke+1/nj[j]
    }
    Kbf <- Kbf/nf
    Ke <- Ke/nf 
    Result1 <- list() 
    TM <- list() 
    TF <- list()
    Tp <- list()
    Beta <- list()
    Tf <- list()
    Pf <- list()
    SI <- list()
    Var <- list()
    Result2 <- list()
    TFP <- list()
    Sigma <- list()
    write("              Analysis for the Model of Half-sib Progeny Test at a Single Site:",file="Result.txt")
    write("                             yijk = u + Bi + Fj + (BF)ij + eijk",file="Result.txt",append = TRUE)
    write(" ",file="Result.txt",append = TRUE)
    write(" ",file="Result.txt",append = TRUE)
    write("   *************************************************************************************",file="Result.txt",append = TRUE)
    write("   *                                                                                   *",file="Result.txt",append = TRUE)
    write(paste("   *  Result for the fixed effect model.                      ",date()," *",sep=""),file="Result.txt",append = TRUE)
    write("   *                                                                                   *",file="Result.txt",append = TRUE)
    write("   *************************************************************************************",file="Result.txt",append = TRUE)
    write(" ",file="Result.txt",append = TRUE)
    write(" ",file="Result.txt",append = TRUE) 
    for(i in 1:(m-2)){
      if(m==3){
        t <- Q %*% Y
      }else{
        t <- Q %*% (Y[,i])
      }
      beta <- invxl%*%t(X)%*%t[1:d2]
      sse <- t(t)%*%t-t(beta)%*%t(X)%*%t[1:d2]
      sigma <- sse/(n-d2)
      stdbeta <- (diag(invxl%*%t(X)%*%X%*%invxl)*sigma)^0.5
      result1[,1] <- beta
      result1[,2] <- stdbeta
      name <- paste("result1",i,sep="")
      assign(name,result1)
      Result1[[i]] <- result1
      C <- rbind(L,H0)
      T <- t(X)%*%X+t(L)%*%L+t(H0)%*%H0
      invT <- solve(T)
      QT <- C%*%invT%*%t(C)
      betaH <- (invT-invT%*%t(C)%*%ginv(QT)%*%C%*%invT)%*%t(X)%*%t[1:d2]
      ssh <- t(t)%*%t-t(betaH)%*%t(X)%*%t[1:d2]
      df1 <- d2
      df2 <- nc-qr(C)$rank
      Ft <- ((ssh-sse)/(df1-df2))/(sse/(n-df1))
      p <- 1-pf(Ft,df1-df2,n-df1)
      TsM[1,2] <- ssh-sse
      TsM[2,2] <- sse
      TsM[3,2] <- ssh
      TsM[1,3] <- TsM[1,2]/TsM[1,1]
      TsM[2,3] <- TsM[2,2]/TsM[2,1]
      TsM[1,4] <- Ft
      TsM[1,5] <- p
      TsM <- round(TsM,4)
      name <- paste("TSM",i,sep="")
      assign(name,TsM)
      TM[[i]] <- TsM
      for(j in 1:3){
        C <- rbind(L,Hk[[j]]) 
        T <- t(X)%*%X+t(L)%*%L+t(Hk[[j]])%*%Hk[[j]]
        invT <- solve(T)
        QT <- C%*%invT%*%t(C)
        betaH <- (invT-invT%*%t(C)%*%ginv(QT)%*%C%*%invT)%*%t(X)%*%t[1:d2]
        ssh <- t(t)%*%t-t(betaH)%*%t(X)%*%t[1:d2]
        df2 <- nc-qr(C)$rank
        Ft <- ((ssh-sse)/(df1-df2))/(sse/(n-df1))
        p <- 1-pf(Ft,df1-df2,n-df1)
        TsF[j,2] <- ssh-sse
        TsF[j,3] <- TsF[j,2]/TsF[j,1]
        TsF[j,4] <- Ft
        TsF[j,5] <- p
        TsF <- round(TsF,4)
      }    
      name <- paste("TSF",i,sep="")
      assign(name,TsF)
      TF[[i]] <- TsF
      for(j in 1:nc){
        H <- matrix(0,nrow=1,ncol=nc)
        H[1,j] <- 1
        C <- rbind(L,H)
        invT <- invxl-(invxl[,j]%*%t(invxl[,j]))/(1+invxl[j,j])
        QT <- C%*%invT%*%t(C)
        betaH <- (invT-invT%*%t(C)%*%ginv(QT)%*%C%*%invT)%*%t(X)%*%t[1:d2]
        ssh <- t(t)%*%t-t(betaH)%*%t(X)%*%t[1:d2]
        df2 <- nc-qr(C)$rank
        Ft <- ((ssh-sse)/(df1-df2))/(sse/(n-df1))
        P <- 1-pf(Ft,df1-df2,n-df1) 
        if(beta[j]>0)tp[j,1]=Ft^0.5 else tp[j,1]=-Ft^0.5 
        tp[j,2] <- P   
      }
      name <- paste("tp",i,sep = "")
      assign(name,tp)
      Tp[[i]] <- tp
      beta <- round(cbind(result1,tp),4)
      name <- paste("beta",i,sep = "")
      assign(name,beta)
      Beta[[i]] <- beta 
      for(j in 2:nf){
        for(k in 1:(j-1)){
          H=matrix(0,nrow=1,ncol=nc)
          jj=j+d
          kk=k+d
          H[1,jj]=1
          H[1,kk]=-1
          C=rbind(L,H)
          invT=invxl-(invxl[,jj]-invxl[,kk])%*%t(invxl[,jj]-invxl[,kk])/(1+invxl[jj,jj]+invxl[kk,kk]-2*invxl[jj,kk])
          QT=C%*%invT%*%t(C)
          betaH=(invT-invT%*%t(C)%*%ginv(QT)%*%C%*%invT)%*%t(X)%*%t[1:d2]
          ssh=t(t)%*%t-t(betaH)%*%t(X)%*%t[1:d2]
          df2=nc-qr(C)$rank
          Ft=((ssh-sse)/(df1-df2))/(sse/(n-df1))
          P=1-pf(Ft,df1-df2,n-df1) 
          if((beta[k]-beta[j])>0)tf[j-1,k]=sprintf("%.4f",Ft^0.5) else  tf[j-1,k]=sprintf("%.4f",-Ft^0.5) 
          if(P<=0.01){
            pf[j-1,k]=paste(sprintf("%.4f",P),"**",sep="")
            tf[j-1,k]=paste(tf[j-1,k],"**",sep="")
          }
          else if(P>0.01&&P<=0.05){
            pf[j-1,k]=paste(sprintf("%.4f",P),"*",sep="")
            tf[j-1,k]=paste(tf[j-1,k],"*",sep="")
          }
          else{
            pf[j-1,k]=sprintf("%.4f",P)
            tf[j-1,k]=tf[j-1,k]
          }
        }
      }
      name <- paste("tf",i,sep="")
      assign(name,tf)
      Tf[[i]] <- tf
      name <- paste("pf",i,sep="")
      assign(name,pf)
      Pf[[i]] <- pf  
      write(paste("   Testing the model for trait ",i,":",sep=""),file="Result.txt",append = TRUE)
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write("      Source             DF     Sum of Squares     Mean Squares     F Value     Pr>F    ",file="Result.txt",append = TRUE)
      write("   -------------------------------------------------------------------------------------",file="Result.txt",append = TRUE)
      write(paste(sprintf("      %-5s",rownames(TM[[i]])[1]),sprintf("%16d",TM[[i]][1,1]),sprintf("%16.4f",TM[[i]][1,2]),sprintf("%17.4f",TM[[i]][1,3]),sprintf("%15.4f",TM[[i]][1,4]),sprintf("%10.4f",TM[[i]][1,5]),sep=""),file="Result.txt",append = TRUE)
      write(paste(sprintf("      %-5s",rownames(TM[[i]])[2]),sprintf("%16d",TM[[i]][2,1]),sprintf("%16.4f",TM[[i]][2,2]),sprintf("%17.4f",TM[[i]][2,3]),sep=""),file="Result.txt",append = TRUE)
      write(paste(sprintf("      %-5s",rownames(TM[[i]])[3]),sprintf("%16d",TM[[i]][3,1]),sprintf("%16.4f",TM[[i]][3,2]),sep=""),file="Result.txt",append = TRUE)
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write(" ",file="Result.txt",append = TRUE) 
      write(paste("   Testing factors for trait ",i,":",sep=""),file="Result.txt",append = TRUE)
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write("   Source                DF     Sum of Squares     Mean Squares     F Value     Pr>F    ",file="Result.txt",append = TRUE)
      write("   -------------------------------------------------------------------------------------",file="Result.txt",append = TRUE)
      for(j in 1:3){
        write(paste(sprintf("   %-19s",rownames(TF[[i]])[j]),sprintf("%5d",TF[[i]][j,1]),sprintf("%16.4f",TF[[i]][j,2]),sprintf("%17.4f",TF[[i]][j,3]),sprintf("%15.4f",TF[[i]][j,4]),sprintf("%10.4f",TF[[i]][j,5]),sep=""),file="Result.txt",append = TRUE)
      }
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write(" ",file="Result.txt",append = TRUE)
      write(paste("   Parameter estimates for trait ",i,":",sep=""),file="Result.txt",append = TRUE)
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write("      Parameter               Estimate       Std Error       T for H0:         Pr>|T|   ",file="Result.txt",append = TRUE)
      write("                                                            Parameter=0                 ",file="Result.txt",append = TRUE)
      write("   -------------------------------------------------------------------------------------",file="Result.txt",append = TRUE)
      for(j in 1:nc){
        write(paste(sprintf("      %-16s",rownames(Beta[[i]])[j]),sprintf("%15.4f",Beta[[i]][j,1]),sprintf("%16.4f",Beta[[i]][j,2]),sprintf("%17.4f",Beta[[i]][j,3]),sprintf("%15.4f",Beta[[i]][j,4]),sep=""),file="Result.txt",append = TRUE)
      }
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write(" ",file="Result.txt",append = TRUE)
      write(paste("   T values of test for difference between two families(females) for trait ",i,":",sep=""),file="Result.txt",append = TRUE)
      kw=c("   =========")
      kk=c("   ---------")
      v=c("        ")
      for(j in 1:(nf-1)){
        kw=paste(kw,"============",sep="")
        kk=paste(kk,"------------",sep="")  
        v=paste(v,sprintf("%12s",t(colnames(Tf[[i]])[j])),sep="")  
      }  
      write(kw,file="Result.txt",append = TRUE) 
      write(v,file="Result.txt",append = TRUE)
      write(kk,file="Result.txt",append = TRUE) 
      z1=1:(nf-1)
      for(j in 1:(nf-1)){
        z1[j]=sprintf("      %-9s",rownames(Tf[[i]])[j]) 
        for(k in 1:j){
          z1[j]=paste(z1[j],sprintf("%-12s",Tf[[i]][j,k]),sep="")
        }
        write(z1[j],file="Result.txt",append = TRUE)  
      }
      write(kw,file="Result.txt",append = TRUE) 
      write("   *p<0.05, **p<0.01",file="Result.txt",append = TRUE)
      write(" ",file="Result.txt",append = TRUE)
      write(" ",file="Result.txt",append = TRUE)
    }
    write("   *************************************************************************************",file="Result.txt",append = TRUE)
    write("   *                                                                                   *",file="Result.txt",append = TRUE)
    write(paste("   *  Result for the random effect model.                     ",date()," *",sep=""),file="Result.txt",append = TRUE)
    write("   *                                                                                   *",file="Result.txt",append = TRUE)
    write("   *************************************************************************************",file="Result.txt",append = TRUE)
    write(" ",file="Result.txt",append = TRUE)
    write(" ",file="Result.txt",append = TRUE)
    for(i in 1:(m-2)){
      if(m==3){
        t <- Q %*% Y
        yay <- c(t(t[1:d2,]) %*% A1 %*% t[1:d2,],t(t[1:d2,]) %*% A2 %*% t[1:d2,],t(Y) %*% A3 %*% Y)
      }else{
        t <- Q %*% (Y[,i])
        yay <- c(t(t[1:d2,]) %*% A1 %*% t[1:d2,],t(t[1:d2,]) %*% A2 %*% t[1:d2,],t(Y[,i]) %*% A3 %*% Y[,i])
      }
      result2[,1] <- invcm %*% yay
      S <- (u1 %*% t(u1))*result2[1,1] + (u2 %*% t(u2))*result2[2,1] + diag(d2)*result2[3,1]
      name <- paste("S",i,sep="")
      assign(name,S)
      SI[[i]] <- S   
      tra1sa1s <- tr(A1 %*% S %*% A1 %*% S)
      tra2sa2s <- tr(A2 %*% S %*% A2 %*% S)
      tra3sa3s <- (n-d2)*result2[3,1]^2
      tra1sa2s <- tr(A1 %*% S1 %*% A2 %*% S1)
      trasas <- c(tra1sa1s,tra2sa2s,tra3sa3s)
      vf <- 2*(invcm[1,]^2 %*% trasas)+4*invcm[1,1]*invcm[1,2]*tra1sa2s
      vbf <- 2*(invcm[2,]^2 %*% trasas)
      ve <- 2*(invcm[3,]^2 %*% trasas)
      var <- c(vf,vbf,ve)
      name <- paste("var",i,sep="")
      assign(name,var)
      Var[[i]] <- var
      result2[,2] <- var^0.5
      name <- paste("result2",i,sep="")
      assign(name,result2)
      Result2[[i]] <- result2
      t3 <- t[(d1+1):d2]
      t4 <- t[(d2+1):n]
      FBF <- (t(t3) %*% t3/(d2-d1))/(t(t4) %*% t4/(n-d2))
      PBF <- 1-pf(FBF,d2-d1,n-d2)
      z <- Lt %*% t[(d0+1):d2]
      ts <- t[(d2+1):(d2+nz)]
      u <- z+((g*diag(1,nz)-inv(Dt))^0.5) %*% ts
      w <- QN %*% u
      w1 <- w[1:(d1-d0)]
      w2 <- w[(d1-d0+1):(d2-d0)]
      FF <- (t(w1) %*% w1/(d1-d0))/(t(w2) %*% w2/(d2-d1))
      PF <- 1-pf(FF,d1-d0,d2-d1)
      F_value <- c(FF,FBF)
      P_value <- c(PF,PBF)
      na <- t(c(NA,NA))
      FP <- rbind(cbind(F_value,P_value),na)
      name <- paste("FP",i,sep="")
      assign(name,FP)
      TFP[[i]] <- FP  
      hf <- result2[1,1]/(result2[1,1]+result2[2,1]*Kbf+result2[3,1]*Ke)
      hi <- 4*result2[1,1]/(result2[1,1]+result2[2,1]+result2[3,1])
      K <- result2[1,1]+result2[2,1]*Kbf+result2[3,1]*Ke
      cv1 <- invcm[1,1]*invcm[2,2]*2*tra1sa2s+invcm[1,2]*invcm[2,2]*2*tra2sa2s+invcm[1,3]*invcm[2,3]*2*(n-d2)*result2[3,1]^2
      cv2 <- invcm[1,3]*invcm[3,3]*2*(n-d2)*result2[3,1]^2
      cv3 <- invcm[2,3]*invcm[3,3]*2*(n-d2)*result2[3,1]^2
      stdhf <- (((result2[1,2])/K)^2+(result2[1,1]^2)*(result2[1,2]^2+(Kbf*result2[2,2])^2+(Ke*result2[3,2])^2+2*Kbf*cv1+2*Ke*cv2+2*Kbf*Ke*cv3)/(K^4)-2*result2[1,1]*(result2[1,2]^2+Kbf*cv1+Ke*cv2)/K^3)^0.5 
      Th <- sum(result2[,1])
      stdhi <- (16*((result2[1,2])/Th)^2+16*(result2[1,1]^2)*(result2[1,2]^2+result2[2,2]^2+result2[3,2]^2+2*cv1+2*cv2+2*cv3)/(Th^4)-32*result2[1,1]*(result2[1,2]^2+cv1+cv2)/Th^3)^0.5
      h <- c(hf,hi)
      stdh <- c(stdhf,stdhi)
      H <- cbind(h,stdh)
      nah <- matrix(NA,nrow=2,ncol=2)
      H <- cbind(H,nah)
      rownames(H) <- c(paste("Hf",i,sep=""),paste("Hi",i,sep=""))
      sigma <- cbind(result2,FP)
      sigma <- round(rbind(sigma,H),4)
      name <- paste("sigma",i,sep="")
      assign(name,sigma)
      Sigma[[i]] <- sigma
      write(paste("   Estimates of variance components and heritabilites for trait ",i,":",sep=""),file="Result.txt",append = TRUE)
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write("      Parameter            Estimate           Std Error        F For H0:        Pr > F  ",file="Result.txt",append = TRUE)
      write("                                                              Parameter=0               ",file="Result.txt",append = TRUE)
      write("   -------------------------------------------------------------------------------------",file="Result.txt",append = TRUE)
      Rnames=c("Sigma_F","Sigma_BF","Sigma_E","Hf","Hi")
      for(j in 1:2){
        write(paste(sprintf("      %-9s",Rnames[j]),sprintf("%19.4f",Sigma[[i]][j,1]),sprintf("%20.4f",Sigma[[i]][j,2]),sprintf("%16.4f",Sigma[[i]][j,3]),sprintf("%16.4f",Sigma[[i]][j,4]),sep=""),file="Result.txt",append = TRUE)
      }
      write(paste(sprintf("      %-9s",Rnames[3]),sprintf("%19.4f",Sigma[[i]][3,1]),sprintf("%20.4f",Sigma[[i]][3,2]),sep=""),file="Result.txt",append = TRUE)
      write(" ",file="Result.txt",append = TRUE)
      for(j in 4:5){
        write(paste(sprintf("      %-9s",Rnames[j]),sprintf("%19.4f",Sigma[[i]][j,1]),sprintf("%20.4f",Sigma[[i]][j,2]),sep=""),file="Result.txt",append = TRUE)
      }
      write("   =====================================================================================",file="Result.txt",append = TRUE)
      write(" ",file="Result.txt",append = TRUE)
    }
    if(m > 3){
      GC <- list()
      EGC <- list()
      GCS <- list() 
      GCf <- matrix(NA,nrow=m-2,ncol=m-2,dimnames=list(c(1:(m-2)),c(1:(m-2))))
      GCbf <- matrix(NA,nrow=m-2,ncol=m-2,dimnames=list(c(1:(m-2)),c(1:(m-2))))
      diag(GCf)<-"1.0000"
      diag(GCbf)<-"1.0000"
      GCef <- matrix(NA,nrow=m-2,ncol=m-2,dimnames=list(c(1:(m-2)),c(1:(m-2))))
      GCebf <- matrix(NA,nrow=m-2,ncol=m-2,dimnames=list(c(1:(m-2)),c(1:(m-2))))
      diag(GCef)<-"0.0000"
      diag(GCebf)<-"0.0000"
      GCMf <- matrix(NA,nrow=m-2,ncol=m-2,dimnames=list(paste("Trait",c(1:(m-2)),sep=""),paste("Trait",c(1:(m-2)),sep="")))
      GCMbf <- matrix(NA,nrow=m-2,ncol=m-2,dimnames=list(paste("Trait",c(1:(m-2)),sep=""),paste("Trait",c(1:(m-2)),sep="")))
      diag(GCMf)<-paste("1.0000","(0.0000)",sep="")
      diag(GCMbf)<-paste("1.0000","(0.0000)",sep="")
      nt=0
      for(i in 1:(m-3)){
        for(j in (i+1):(m-2)){
          t1 <- Q %*% Y[,i]
          t2 <- Q %*% Y[,j]
          y1ay2 <- c(t(t1[1:d2,]) %*% A1 %*% t2[1:d2,],t(t1[1:d2,]) %*% A2 %*% t2[1:d2,],t(Y[,i]) %*% A3 %*% Y[,j])
          cov <- c(invcm %*% y1ay2)
          rf <- cov[1]/(Result2[[i]][1,1]*Result2[[j]][1,1])^0.5
          rbf <- cov[2]/(Result2[[i]][2,1]*Result2[[j]][2,1])^0.5
          Gc <- c(rf,rbf)
          name <- paste("Gc",i,j,sep="")
          assign(name,Gc)
          S12 <- (u1 %*% t(u1))*cov[1]+(u2 %*% t(u2))*cov[2]+diag(d2)*cov[3]
          tra1s1a1s12 <- tr(A1 %*% SI[[i]] %*% A1 %*% S12)
          tra2s1a2s12 <- tr(A2 %*% SI[[i]] %*% A2 %*% S12)
          tra3s1a3s12 <- (n-d2)*Result2[[i]][3,1]*cov[3]
          tra1s1a2s12 <- tr(A1 %*% SI[[i]] %*% A2 %*% S12)
          trasas121 <- c(tra1s1a1s12,tra2s1a2s12,tra3s1a3s12)
          tra1s2a1s12 <- tr(A1 %*% SI[[j]] %*% A1 %*% S12)
          tra2s2a2s12 <- tr(A2 %*% SI[[j]] %*% A2 %*% S12)
          tra3s2a3s12 <- (n-d2)*Result2[[j]][3,1]*cov[3]
          tra1s2a2s12 <- tr(A1 %*% SI[[j]] %*% A2 %*% S12)
          trasas122 <- c(tra1s2a1s12,tra2s2a2s12,tra3s2a3s12)
          tra1s12a1s12 <- tr(A1 %*% S12 %*% A1 %*% S12)
          tra2s12a2s12 <- tr(A2 %*% S12 %*% A2 %*% S12)
          tra3s12a3s12 <- (n-d2)*cov[3]^2
          tra1s12a2s12 <- tr(A1 %*% S12 %*% A2 %*% S12)
          trasas1212 <- c(tra1s12a1s12,tra2s12a2s12,tra3s12a3s12)
          tra1s1a1s2 <- tr(A1 %*% SI[[i]] %*% A1 %*% SI[[j]])
          tra2s1a2s2 <- tr(A2 %*% SI[[i]] %*% A2 %*% SI[[j]])
          tra3s1a3s2 <- (n-d2)*Result2[[i]][3,1]*Result2[[j]][3,1]
          tra1s1a2s2 <- tr(A1 %*% SI[[i]] %*% A2 %*% SI[[j]])
          trasas12 <- c(tra1s1a1s2,tra2s1a2s2,tra3s1a3s2)
          vf12 <- invcm[1,]^2 %*% (trasas1212+trasas12)+2*invcm[1,1]*invcm[1,2]*(tra1s12a2s12+tra1s1a2s2)
          cvf121 <- 2*(invcm[1,]^2 %*% trasas121)+4*invcm[1,1]*invcm[1,2]*tra1s1a2s12
          cvf122 <- 2*(invcm[1,]^2 %*% trasas122)+4*invcm[1,1]*invcm[1,2]*tra1s2a2s12
          cvf1f2 <- 2*(invcm[1,]^2 %*% trasas1212)+4*invcm[1,1]*invcm[1,2]*tra1s12a2s12
          vrf <- (vf12/cov[1]^2+Var[[i]][1]/(4*Result2[[i]][1,1]^2)+Var[[j]][1]/(4*Result2[[j]][1,1]^2)-cvf121/(cov[1]*Result2[[i]][1,1])-cvf122/(cov[1]*Result2[[j]][1,1])+cvf1f2/(2*Result2[[i]][1,1]*Result2[[j]][1,1]))*rf^2
          erf <- vrf^0.5         
          vbf12 <- invcm[2,]^2 %*% (trasas1212+trasas12)
          cvbf121 <- 2*(invcm[2,]^2 %*% trasas121)
          cvbf122 <- 2*(invcm[2,]^2 %*% trasas122)
          cvbf1bf2 <- 2*(invcm[2,]^2 %*% trasas1212)
          vrbf <- (vbf12/cov[2]^2+Var[[i]][2]/(4*Result2[[i]][2,1]^2)+Var[[j]][2]/(4*Result2[[j]][2,1]^2)-cvbf121/(cov[2]*Result2[[i]][2,1])-cvbf122/(cov[2]*Result2[[j]][2,1])+cvbf1bf2/(2*Result2[[i]][2,1]*Result2[[j]][2,1]))*rbf^2
          erbf <- vrbf^0.5
          EGc <- c(erf,erbf)
          name <- paste("EGc",i,j,sep="")
          assign(name,EGc)
          GCs <- round(cbind(Gc,EGc),4)
          rownames(GCs) <- c(paste("GC",i,j,"_F",sep=""),paste("GC",i,j,"_BF",sep=""))
          colnames(GCs) <- c("GC","Std Error")
          name <- paste("GCs",i,j,sep="")
          assign(name,GCs)
          nt <- nt+1
          GC[[nt]] <- Gc
          EGC[[nt]] <- EGc
          GCS[[nt]] <- GCs 
          GCf[i,j] <- GCf[j,i] <- sprintf("%.4f",GCs[1,1])
          GCbf[i,j] <- GCbf[j,i] <- sprintf("%.4f",GCs[2,1])
          GCef[i,j] <- GCef[j,i] <- sprintf("%.4f",GCs[1,2])
          GCebf[i,j] <- GCebf[j,i] <- sprintf("%.4f",GCs[2,2])
          GCMf[i,j] <- GCMf[j,i] <- paste(sprintf("%.4f",GCs[1,1]),paste("(",sprintf("%.4f",GCs[1,2]),")",sep=""),sep="")
          GCMbf[i,j] <- GCMbf[j,i] <- paste(sprintf("%.4f",GCs[2,1]),paste("(",sprintf("%.4f",GCs[2,2]),")",sep=""),sep="")
        }
      }
      write("   Genetic correlation matrix of family effects with standard error in brackets",file="Result.txt",append = TRUE)
      kw=c("   ===============")
      kk=c("   ---------------")
      v=c("       Trait")
      for(i in 1:(m-2)){
        kw=paste(kw,"=============",sep="")
        kk=paste(kk,"-------------",sep="")  
        v=paste(v,sprintf("%13s",t(colnames(GCf)[i])),sep="")  
      }  
      write(kw,file="Result.txt",append = TRUE) 
      write(v,file="Result.txt",append = TRUE)
      write(kk,file="Result.txt",append = TRUE)
      zf=1:(m-2)
      zef=1:(m-2)
      for(i in 1:(m-2)){
        zf[i]=sprintf("         %1s    ",rownames(GCf)[i])
        zef[i]=sprintf("               ")
        for(j in 1:(m-2)){
          zf[i]=paste(zf[i],sprintf("%13s",GCf[i,j]),sep="")
          zef[i]=paste(zef[i],sprintf("%13s",paste("(",GCef[i,j],")",sep="")),sep="")
        }
      }
      for(i in 1:(m-3)){
        write(zf[i],file="Result.txt",append = TRUE) 
        write(zef[i],file="Result.txt",append = TRUE) 
        write("     ",file="Result.txt",append = TRUE) 
      }    
      write(zf[m-2],file="Result.txt",append = TRUE) 
      write(zef[m-2],file="Result.txt",append = TRUE)
      write(kw,file="Result.txt",append = TRUE)
      write("     ",file="Result.txt",append = TRUE)   
      write("   Genetic correlation matrix of block*family effects with standard error in brackets",file="Result.txt",append = TRUE)
      kw=c("   ===============")
      kk=c("   ---------------")
      v=c("       Trait")
      for(i in 1:(m-2)){
        kw=paste(kw,"=============",sep="")
        kk=paste(kk,"-------------",sep="")  
        v=paste(v,sprintf("%13s",t(colnames(GCbf)[i])),sep="")  
      }  
      write(kw,file="Result.txt",append = TRUE) 
      write(v,file="Result.txt",append = TRUE)
      write(kk,file="Result.txt",append = TRUE)
      zbf=1:(m-2)
      zebf=1:(m-2)
      for(i in 1:(m-2)){
        zbf[i]=sprintf("         %1s    ",rownames(GCbf)[i])
        zebf[i]=sprintf("               ")
        for(j in 1:(m-2)){
          zbf[i]=paste(zbf[i],sprintf("%13s",GCbf[i,j]),sep="")
          zebf[i]=paste(zebf[i],sprintf("%13s",paste("(",GCebf[i,j],")",sep="")),sep="")
        }
      }
      for(i in 1:(m-3)){
        write(zbf[i],file="Result.txt",append = TRUE) 
        write(zebf[i],file="Result.txt",append = TRUE) 
        write("     ",file="Result.txt",append = TRUE) 
      }    
      write(zbf[m-2],file="Result.txt",append = TRUE) 
      write(zebf[m-2],file="Result.txt",append = TRUE)
      write(kw,file="Result.txt",append = TRUE) 
    }
  }
  file.show("Result.txt",title="Result")
}
